//+------------------------------------------------------------------+
//|                                             Aroon oscillator.mq4 |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1  Silver
#property indicator_color2  LimeGreen
#property indicator_color3  LimeGreen
#property indicator_color4  PaleVioletRed
#property indicator_color5  PaleVioletRed
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_width4  2
#property indicator_width5  2
#property indicator_minimum -101
#property indicator_maximum  101


extern int    AroonPeriod = 25;
extern int    PriceHigh   = PRICE_CLOSE;
extern int    PriceLow    = PRICE_CLOSE;
extern int    MaPeriod    = 14;
extern int    MaMethod    = MODE_EMA;
extern double Filter      = 50;

//
//
//
//
//

double buffer1[];
double buffer2[];
double buffer3[];
double buffer4[];
double buffer5[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,buffer1);
   SetIndexBuffer(1,buffer2);
   SetIndexBuffer(2,buffer3);
   SetIndexBuffer(3,buffer4);
   SetIndexBuffer(4,buffer5);
      SetLevelValue(0, Filter);
      SetLevelValue(1,-Filter);
   IndicatorShortName("Aroon oscillator ("+AroonPeriod+")");
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double prices[][2];
#define _high 0
#define _low  1
int start()
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
      if (buffer1[limit] >  Filter) CleanPoint(limit,buffer2,buffer3);
      if (buffer1[limit] < -Filter) CleanPoint(limit,buffer4,buffer5);
      if (ArrayRange(prices,0) != Bars) ArrayResize(prices,Bars);
      
   
   //
   //
   //
   //
   //
   
   for(i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      prices[r][_high] = iMA(NULL,0,MaPeriod,0,MaMethod,PriceHigh,i);
      prices[r][_low ] = iMA(NULL,0,MaPeriod,0,MaMethod,PriceLow ,i);
         double max = prices[r][_high]; double maxi = 0;
         double min = prices[r][_low ]; double mini = 0;
         for (int k=1; k<=AroonPeriod && (r-k)>=0; k++)
         {
             if (max<prices[r-k][_high]) { maxi=k; max = prices[r-k][_high]; }
             if (min>prices[r-k][_low ]) { mini=k; min = prices[r-k][_low ]; }
         }                  
         buffer1[i] = 100.0*(mini-maxi)/AroonPeriod;
         buffer2[i] = EMPTY_VALUE;
         buffer3[i] = EMPTY_VALUE;
         buffer4[i] = EMPTY_VALUE;
         buffer5[i] = EMPTY_VALUE;
                  if (buffer1[i]> Filter) PlotPoint(i,buffer2,buffer3,buffer1);
                  if (buffer1[i]<-Filter) PlotPoint(i,buffer4,buffer5,buffer1);
   }
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
      if (first[i+2] == EMPTY_VALUE) {
          first[i]    = from[i];
          first[i+1]  = from[i+1];
          second[i]   = EMPTY_VALUE;
         }
      else {
          second[i]   = from[i];
          second[i+1] = from[i+1];
          first[i]    = EMPTY_VALUE;
         }
      }
   else
      {
         first[i]   = from[i];
         second[i]  = EMPTY_VALUE;
      }
}